//import QtQuick 1.1
//import WorkoutManager 1.0

//import "string_format.js" as Format
//import "program_setup.js" as Fields
//import "Globals.js" as Globals

//Item {
//    id: root
//    property alias model: myListView.model
//    property QtObject timeItem
//    property QtObject distItem
//    property QtObject calItem
//    property bool timeGoal: true
//    property bool distGoal: false
//    property int maxCalPerHr: 1600

//    onModelChanged: modelPostProcessing()

//    function setParameter(type, value) {
//        if(!root.model)
//            return
//        var obj = root.model.find("fieldType", type)
//        if(obj) {
//            mainProgItem.valueEntered = true
//            if(value > obj.maxValue)
//                obj.dataValue = obj.maxValue
//            else if(value < obj.minValue)
//                obj.dataValue = obj.minValue
//            else
//                obj.dataValue = value
//            mainProgItem.valueEntered = false
//        }
//    }

//    // Validate data relationships when any value is changed
//    Connections {
//        target: root.model ? root.model : null
//        ignoreUnknownSignals: true
//        onDataChanged: {
//            if(isTreadmill && calItem) // Treadmill calorie goal setup
//                validateTreadCalorieGoal()
//            if (!isTreadmill && calItem) {
//                validateNonTreadCalorieGoal()
//            }
//        }
//    }

//    function getParameter(type) {
//        if(!root.model)
//            return
//        var obj = root.model.find("fieldType", type)
//        if(obj)
//            return obj.dataValue
//        else
//            return undefined
//    }

//    function recalcMaxSegments() {
//        myListView.calculateMaxSegmentsFromTime()
//    }

//    function maxTreadCalories( speed, incline, weight, time) {
//        var calsPerHr = workoutManager.treadmillCalsPerHour(speed, incline, weight)
//        return time * calsPerHr / 60.0
//    }

//    function validateTreadCalorieGoal() {
//        var speed = getParameter(WorkoutProgram.MAX_SPEED_TYPE)
//        var inclineIndex = getParameter(WorkoutProgram.MAX_INCLINE_TYPE)
//        var incline = (workoutProgram.inclineTable[inclineIndex]/10).toFixed(1)
//        var weight = getParameter(WorkoutProgram.WEIGHT_TYPE)
//        if (root.model.find("fieldType", WorkoutProgram.WEIGHT_TYPE).units === "KG") {
//            weight = Math.round(Globals.kgToPound(weight))
//        }
//        var time = getParameter(WorkoutProgram.TIME_TYPE)
//        var maxCal = maxTreadCalories(speed, incline, weight, time)
//        var calgoal = getParameter(WorkoutProgram.CALORIES_TYPE)
//        setParameter(WorkoutProgram.CALORIE_POTENTIAL_TYPE, maxCal.toFixed(0))

//        if(calgoal > maxCal) {
//            setParameter(WorkoutProgram.CALORIES_TYPE, maxCal.toFixed(0))
//        }
//    }

//    function validateNonTreadCalorieGoal() {
//        // when weight, time, or calories change, recalculate max and show warning if needed
//        var weight = getParameter(WorkoutProgram.WEIGHT_TYPE)
//        root.maxCalPerHr = workoutManager.bikeEllipticalMaxCalsPerHour(weight)
//        var calsperhr = Math.floor(calItem.dataValue / (timeItem.dataValue / 60))
//        console.log("max cals per hr is", root.maxCalPerHr, "user cals per hour is", calsperhr)
//        if (calsperhr > root.maxCalPerHr) {
//            calWarning.visible = true
//        } else {
//            calWarning.visible = false
//        }
//    }

//    function isSpeedType(fieldType) {
//        switch (fieldType) {
//            case WorkoutProgram.SPEED_TYPE:
//            case WorkoutProgram.MAX_SPEED_TYPE:
//            case WorkoutProgram.WALK_SPEED_TYPE:
//            case WorkoutProgram.RUN_SPEED_TYPE:
//            case WorkoutProgram.WORK_SPEED_TYPE:
//            case WorkoutProgram.REST_SPEED_TYPE:
//                return true
//            default:
//                return false
//        }
//    }

//    Connections {
//        target: timeItem
//        onDataChanged: {
//            if(timeItem.dataValue > 0) {
//                root.timeGoal = true
//                root.distGoal = false
//            }
//        }
//    }
//    Connections {
//        target: distItem
//        onDataChanged: {
//            if(distItem.dataValue > 0) {
//                root.timeGoal = false
//                root.distGoal = true
//            }
//        }
//    }

//    Item {
//        id: calWarning

//        visible: false
//        anchors.bottom: parent.bottom
//        anchors.bottomMargin: 50
//        anchors.left: parent.left
//        anchors.leftMargin: 10
//        width: 450
//        height: 50

//        Image{
//            id: calCautionSymbol
//            source: "graphics/Icon_Warning.png"
//            anchors.left: parent.left
//            anchors.verticalCenter: parent.verticalCenter
//        }

//        Text {
//            text: qsTr( "The calorie goal chosen is too high for selected workout time.") + application.emptyString
//            wrapMode: Text.WordWrap
//            font.pixelSize: 16
//            anchors.left: calCautionSymbol.right
//            anchors.verticalCenter: parent.verticalCenter
//        }
//    }

//    function modelPostProcessing()
//    {
//        // get references to the time and distance model items for making the time/dist mutex for manual workout
//        timeItem = root.model.find("fieldType", WorkoutProgram.TIME_TYPE)
//        if (timeItem) {
//            root.model.setProperty(timeItem.fieldIndex - 1, "maxValue", options.workoutTimeMax)
//            if (timeItem.dataValue > 0)
//                setParameter(WorkoutProgram.TIME_TYPE, timeItem.dataValue) // re-set value in case it is now over max
//        }

//        distItem = root.model.find("fieldType", WorkoutProgram.DISTANCE_TYPE)
//        if(!distItem) {
//            distItem = root.model.find("fieldType", WorkoutProgram.DISTANCE_QUICK_TYPE)
//            if (!distItem) {
//                distItem = root.model.find("fieldType", WorkoutProgram.FIXED_DISTANCE_TYPE)
//                if (distItem) {
//                    console.log("Fixed Dist Item!")
//                }
//            }
//        }

//        if(isTreadmill)
//            calItem = root.model.find("fieldType", WorkoutProgram.CALORIE_POTENTIAL_TYPE)
//        else
//            calItem = root.model.find("fieldType", WorkoutProgram.CALORIES_TYPE)


//        if(isTreadmill && calItem) {
//            validateTreadCalorieGoal()
//        }
//        if (!isTreadmill && calItem) {
//            validateNonTreadCalorieGoal()
//        }

//        root.timeGoal = false
//        root.distGoal = false
//        if(timeItem && timeItem.dataValue > 0)
//            root.timeGoal = true
//        else if(distItem)
//            root.distGoal = true

//        for(var i = 0; i < myListView.model.count; i++)
//        {
//            var item = myListView.model.get(i)

//            switch(item.fieldType)
//            {
//            case WorkoutProgram.WORK_HEARTRATE_TYPE:
//            case WorkoutProgram.REST_HEARTRATE_TYPE:
//            case WorkoutProgram.TARGET_HEARTRATE_TYPE:
//                mainProgItem.targetHRType = targetHRTypeEnum.target; // Target
//                myListView.calculateHRPercentage();
//                break;

//            case WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE:
//                mainProgItem.targetHRType = targetHRTypeEnum.aerobic; // Aerobic
//                myListView.calculateHRFromAge();
//                break;
//            case WorkoutProgram.SEGMENT_TYPE:
//                mainProgItem.numSegs = item.dataValue;
//                break;
//            case WorkoutProgram.TIME_TYPE:
//                mainProgItem.workTime = item.dataValue;
//                break;
//            case WorkoutProgram.DISTANCE_TYPE:
//                break;
//            case WorkoutProgram.PACE_TYPE:
//                mainProgItem.paceLevelForCustom = item.dataValue;
//                break;
//            case WorkoutProgram.WORKLOAD_TYPE:
//                mainProgItem.workloadLevelForCustom = item.dataValue;
//                break;
//            case WorkoutProgram.AGE_TYPE:
//                mainProgItem.ageForProgSummary = item.dataValue;
//                break;
//            case WorkoutProgram.WEIGHT_TYPE:
//                mainProgItem.weightForProgSummary = item.dataValue;
//                break;
//            }
//        }
//        dataItemChanged()

//        myListView.currentIndex = 0

//        var item = myListView.model.get(selectedIndex)
//        keypad.clear()
//        keypad.length = myListView.getMaxDigit(item.maxValue)
//        console.debug("index changed to ", selectedIndex, ". Max Value is ", item.maxValue, ". Length is ", keypad.length)
//    }

//    function validateParam(i) {
//        var item = myListView.model.get(i)
//        var correctionsMade = 0
//        var newValue = item.dataValue

//        // skip ignored values in mutual exclusive goal setting (manual workout time vs. distance)
//        if(root.timeGoal && item.fieldType === WorkoutProgram.DISTANCE_TYPE)
//            return 0
//        if(root.distGoal && item.fieldType === WorkoutProgram.TIME_TYPE)
//            return 0

//        if (item.dataValue > item.maxValue) {
//            newValue = item.maxValue
//            // Change invalid speed entries of any type to minimum speed
//            if(item.fieldType == WorkoutProgram.SPEED_TYPE || item.fieldType == WorkoutProgram.MAX_SPEED_TYPE ||
//                    item.fieldType == WorkoutProgram.WORK_SPEED_TYPE || item.fieldType == WorkoutProgram.REST_SPEED_TYPE ||
//                    item.fieldType == WorkoutProgram.RUN_SPEED_TYPE  || item.fieldType == WorkoutProgram.WALK_SPEED_TYPE){
//                newValue = item.minValue
//            }
//            // Change invalid incline entries to zero grade
//            else if(item.units === "%"){
//                newValue = 0
//            }
//        }
//        else if (item.dataValue < item.minValue) {
//            newValue = item.minValue
//        }

//        if(item.dataValue != newValue) {
//            mainProgItem.valueEntered = true;
//            myListView.model.setProperty(i, "dataValue", newValue);
//            mainProgItem.valueEntered = false;
//            correctionsMade++
//        }
//        return correctionsMade
//    }

//    function validateEntries() {
//        var numOutOfRange = 0;
//        for (var x = 0; x < myListView.model.count; x++) {
//            numOutOfRange += validateParam(x)
//        }
//        // zero out a parameter if it is excluded by mutual exclusive goal
//        if(!root.timeGoal) {
//            if(timeItem)
//                timeItem.dataValue = 0
//        }
//        if(!root.distGoal) {
//            if(distItem)
//                distItem.dataValue = 0
//        }
//        if(calWarning.visible)
//            numOutOfRange++
//        return numOutOfRange
//    }

//    ListView {
//        id: myListView
//        anchors.fill: parent
//        interactive: false
//        delegate: myDelegate

//        onCurrentIndexChanged: {
//            keypad.clear()
//            var item = model.get(currentIndex)
//            if(!item)
//                return
//            if(item.units === "%") {
//                keypad.length = 3
//                keypad.show_entry = true
//                keypad.decimalPlaces = 1
//            }
//            else {
//                keypad.length = getMaxDigit(item.maxValue) + item.precision
//                keypad.decimalPlaces = item.precision
//                keypad.show_entry = false
//            }

//            keypad.units = item.units
//        }

//        function getValueString(item)
//        {
//            if (item.precision > 0) {
//                if (root.isSpeedType(item.fieldType)) {
//                    var valConverted = options.metricUnits ? Globals.mileToKm(item.dataValue) : parseFloat(item.dataValue)
//                    return valConverted.toFixed(item.precision)
//                } else {
//                    var str = parseFloat(item.dataValue)
//                    if(!root.distGoal && (item.fieldType == WorkoutProgram.DISTANCE_TYPE || item.fieldType == WorkoutProgram.DISTANCE_QUICK_TYPE)) {
//                        return "--";
//                    }

//                    // special case: display "5K" rather than 5.0K for distance buttons
//                    if (item.fieldType === WorkoutProgram.DISTANCE_QUICK_TYPE && str - Math.floor(str) === 0.0) {
//                        return Math.floor(str)
//                    }

//                    return str.toFixed(item.precision)
//                }
//            }
//            else {
//                if (item.fieldType == WorkoutProgram.TIME_TYPE) { // Time
//                    mainProgItem.workTime = item.dataValue;
//                    mainProgItem.segTime = ((item.dataValue * 60) / mainProgItem.numSegs);
//                    if(!root.timeGoal) {
//                        return "--";
//                    }
//                    return item.dataValue;
//                }
//                else if (item.fieldType == WorkoutProgram.TIMEREADONLY_TYPE) {
////                    if(!root.timeGoal) {
////                        return "--";
////                    }
//                    return item.dataValue;
//                }
//                else if (item.fieldType == WorkoutProgram.PACE_TYPE) { // Pace
//                    mainProgItem.paceLevelForCustom = item.dataValue;
//                    return item.dataValue;
//                }
//                else if (item.fieldType == WorkoutProgram.WORKLOAD_TYPE) { // Workload
//                    mainProgItem.workloadLevelForCustom = item.dataValue;
//                    return item.dataValue;
//                }
//                else if (item.fieldType == WorkoutProgram.AGE_TYPE) { // Age
//                    mainProgItem.ageForProgSummary = item.dataValue;
//                    return item.dataValue;
//                }
//                else if (item.fieldType == WorkoutProgram.WEIGHT_TYPE) { // Weight
//                    mainProgItem.weightForProgSummary = item.dataValue;
//                    return item.dataValue;
//                }
//                else if (item.fieldType == WorkoutProgram.GENDER_TYPE) { // Weight
//                    return item.dataValue ? qsTr("F", "Female Gender Intial") + application.emptyString : qsTr("M", "Male Gender Intial") + application.emptyString
//                }
//                else if (item.fieldType == WorkoutProgram.INCLINE_TYPE || item.fieldType == WorkoutProgram.MAX_INCLINE_TYPE) { // incline
//                    return (workoutProgram.inclineTable[item.dataValue]/10).toFixed(1)
//                }
//                else if (root.isSpeedType(item.fieldType)) {
//                    return options.metricUnits ? Globals.mileToKm(item.dataValue) : item.dataValue
//                }
//                else {
//                    return item.dataValue;
//                }
//            }
//        }

//        function calculateHRPercentage () {
//            var userAge = 0;
//            var tempHR = 0;
//            var tempCalcHRPercent = 0;

//            for (var i = 0; i < myListView.count; i++)
//            {
//                if (myListView.model.get(i).fieldIndex == 1) {
//                    userAge = myListView.model.get(i).dataValue;
//                }
//                else if (myListView.model.get(i).fieldType == WorkoutProgram.WORK_HEARTRATE_TYPE ||
//                         myListView.model.get(i).fieldType == WorkoutProgram.REST_HEARTRATE_TYPE ||
//                         myListView.model.get(i).fieldType == WorkoutProgram.TARGET_HEARTRATE_TYPE ||
//                         myListView.model.get(i).fieldType == WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE) {
//                    // HR
//                    tempHR = myListView.model.get(i).dataValue;
//                }
//                if (userAge > 0 && tempHR > 0) {
//                    if (tempHR > (220 - userAge)) {
//                        tempHR = (220 - userAge);
//                        myListView.model.setProperty(i, "dataValue", Math.round(tempHR));
//                    }
//                    tempCalcHRPercent = ((tempHR / (220 - userAge)) * 100);
//                    myListView.model.setProperty(i, "heartRatePercentage", Math.round(tempCalcHRPercent));
//                    tempHR = 0;
//                }
//            }

//        }

//        function calculateHRFromAge () {
//            var userAge = 0;
//            var tempHR = 0;
//            var tempHRPercent = 0;

//            for (var i = 0; i < myListView.count; i++)
//            {
//                if (myListView.model.get(i).fieldIndex == 1) {
//                    userAge = myListView.model.get(i).dataValue;
//                }
//                else if (myListView.model.get(i).fieldType == WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE) {
//                    tempHRPercent = myListView.model.get(i).heartRatePercentage;
//                }
//                if (userAge > 0 && tempHRPercent > 0) {
//                    tempHR = ((220 - userAge) * (tempHRPercent / 100.0));
//                    myListView.model.setProperty(i, "dataValue", Math.round(tempHR));
//                    tempHRPercent = 0;
//                }
//            }
//        }

//        function calculateMaxSegmentsFromTime() {
//            if (!myListView.model)
//                return

//            var timeMins = getParameter(WorkoutProgram.TIME_TYPE)
//            var maxSegs = Math.max(2, Math.min(30, timeMins))
//            var item = myListView.model.find("fieldType", WorkoutProgram.SEGMENT_TYPE)
//            if(!item)   // no segment count setup field, nothing to do
//                return
//            var index = item.fieldIndex - 1
//            myListView.model.setProperty(index, "maxValue", maxSegs)
//            if (getParameter(WorkoutProgram.SEGMENT_TYPE) > maxSegs) {
//                // the next line is needed because the slider's binding to model.dataValue gets broken somewhere
//                myListView.contentItem.children[index + 1]._slider3.value = maxSegs
//            }
//        }

//        function getBaseFieldHeight(fieldType)
//        {
//            switch(fieldType)
//            {
//            case WorkoutProgram.MAX_SPEED_TYPE:
//            case WorkoutProgram.MAX_INCLINE_TYPE:
//            case WorkoutProgram.LEVEL_TYPE:
//            case WorkoutProgram.SPEED_TYPE:
//            case WorkoutProgram.RUN_SPEED_TYPE:
//            case WorkoutProgram.WORK_SPEED_TYPE:
//            case WorkoutProgram.WALK_SPEED_TYPE:
//            case WorkoutProgram.REST_SPEED_TYPE:
//            case WorkoutProgram.DISTANCE_TYPE:
//            case WorkoutProgram.DISTANCE_QUICK_TYPE:
//            case WorkoutProgram.SEGMENT_TYPE:
//            case WorkoutProgram.TIME_TYPE:
//            case WorkoutProgram.PACE_TYPE:
//            case WorkoutProgram.WORKLOAD_TYPE:
//            case WorkoutProgram.AGE_TYPE:
//            case WorkoutProgram.WEIGHT_TYPE:
//            case WorkoutProgram.GENDER_TYPE:
//            case WorkoutProgram.INCLINE_TYPE:
//            case WorkoutProgram.CALORIES_TYPE:
//                return 80;

//            case WorkoutProgram.WORK_HEARTRATE_TYPE:
//            case WorkoutProgram.REST_HEARTRATE_TYPE:
//            case WorkoutProgram.TARGET_HEARTRATE_TYPE:
//            case WorkoutProgram.HEARTRATEREADONLY_TYPE:
//            case WorkoutProgram.FIXED_DISTANCE_TYPE:
//            case WorkoutProgram.TIMEREADONLY_TYPE:
//            case WorkoutProgram.CALORIE_POTENTIAL_TYPE:
//                return 120;
//            }
//        }

//        function getBackgroundSource(fieldType)
//        {
//            switch(fieldType)
//            {
//            case WorkoutProgram.MAX_SPEED_TYPE:
//            case WorkoutProgram.MAX_INCLINE_TYPE:
//            case WorkoutProgram.LEVEL_TYPE:
//            case WorkoutProgram.SPEED_TYPE:
//            case WorkoutProgram.RUN_SPEED_TYPE:
//            case WorkoutProgram.WORK_SPEED_TYPE:
//            case WorkoutProgram.WALK_SPEED_TYPE:
//            case WorkoutProgram.REST_SPEED_TYPE:
//            case WorkoutProgram.DISTANCE_TYPE:
//            case WorkoutProgram.DISTANCE_QUICK_TYPE:
//            case WorkoutProgram.SEGMENT_TYPE:
//            case WorkoutProgram.TIME_TYPE:
//            case WorkoutProgram.PACE_TYPE:
//            case WorkoutProgram.WORKLOAD_TYPE:
//            case WorkoutProgram.AGE_TYPE:
//            case WorkoutProgram.WEIGHT_TYPE:
//            case WorkoutProgram.GENDER_TYPE:
//            case WorkoutProgram.INCLINE_TYPE:
//            case WorkoutProgram.CALORIES_TYPE:
//                return "graphics/setup/Setup_Small_Down.png"

//            case WorkoutProgram.WORK_HEARTRATE_TYPE:
//            case WorkoutProgram.REST_HEARTRATE_TYPE:
//            case WorkoutProgram.TARGET_HEARTRATE_TYPE:
//            case WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE:
//            case WorkoutProgram.FIXED_DISTANCE_TYPE:
//            case WorkoutProgram.TIMEREADONLY_TYPE:
//            case WorkoutProgram.CALORIE_POTENTIAL_TYPE:
//                return "graphics/setup/Setup_Large_Down.png"
//            }
//        }

//        function getMaxDigit(maxValue)
//        {
//            var str = maxValue.toString()
//            return str.length
//        }

//        Keypad {
//            id: keypad

//            property variant model: myListView.model
//            property int currentFieldType: getFieldType()

//            function getFieldType() {
//                if(!model)
//                    return -1
//                var field = model.get(myListView.currentIndex)
//                if(!field)
//                    return -1
//                return field.fieldType
//            }

//            width: 320
//            anchors.right: parent.right
//            anchors.rightMargin: 500
//            anchors.verticalCenter: parent.verticalCenter
//            anchors.verticalCenterOffset: show_entry ? 0 : 50
//            show_entry: false
//            allow_close: false

//            visible: !(currentFieldType == WorkoutProgram.GENDER_TYPE || currentFieldType == WorkoutProgram.FIXED_DISTANCE_TYPE)
//            enabled: !(currentFieldType == WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE || currentFieldType == WorkoutProgram.TIMEREADONLY_TYPE)  // don't allow changing read-only field

//            onValueEntered: {
//                if(keypad.value && keypad.value != "0.0") {
//                    var item = model.get(mainProgItem.selectedIndex)
//                    var tmp
//                    mainProgItem.valueEntered = true;
//                    if(item.units === "%"){
//                        tmp = workoutProgram.tableIndexOfClosestValue(workoutProgram.inclineTable,keypad.value*10)
//                        console.debug(tmp + " index")
//                        model.setProperty(mainProgItem.selectedIndex, "dataValue", tmp);
//                    } else if (root.isSpeedType(item.fieldType) && options.metricUnits) {
//                        // when the user is using metric, find the closest possible mph value in the speed table to correct their entry
//                        tmp = Globals.kmToMile(parseFloat(value))
//                        tmp = workoutProgram.tableClosestValue(workoutProgram.speedTable, Math.round(tmp*10))
//                        if (isNaN(tmp))
//                            tmp = workoutProgram.speedTable[0]
//                        model.setProperty(mainProgItem.selectedIndex, "dataValue", tmp/10)
//                    }
//                    else
//                        model.setProperty(mainProgItem.selectedIndex, "dataValue", keypad.value);
//                    mainProgItem.valueEntered = false;

//                    var corrections = validateParam(mainProgItem.selectedIndex)
//                    if (item.fieldType === WorkoutProgram.SEGMENT_TYPE) {
//                        mainProgItem.numSegs = model.get(mainProgItem.selectedIndex).dataValue
//                    }
//                    mainProgItem.valueEntered = false;

//                    // go to next field when enter pressed, if entry was not corrected by validation
//                    if(corrections == 0) {
//                        myListView.incrementCurrentIndex()
//                        mainProgItem.selectedIndex = myListView.currentIndex
//                        mainProgItem.fieldIndex = myListView.currentIndex+1;
//                    }
//                }
//            }
//            onKeyPress: {
//                if (key != "ENTER") {
//                    if(model.get(mainProgItem.selectedIndex).units === "%"){
//                        ;
//                    }
//                    else {
//                        if (keypad.value) {
//                            var item = model.get(mainProgItem.selectedIndex)
//                            var val = keypad.value
//                            if (root.isSpeedType(item.fieldType) && options.metricUnits) {
//                                val = Globals.kmToMile(parseFloat(val))
//                            }
//                            model.setProperty(mainProgItem.selectedIndex, "dataValue", val);

//                            if (item.fieldType === WorkoutProgram.TIME_TYPE) {
//                                myListView.calculateMaxSegmentsFromTime()
//                            }

//                        }
//                    }
//                }
//            }
//        }

//        Text {
//            id: prog_setup_desc_text
//            anchors.top: parent.top
//            anchors.topMargin: 200
//            anchors.right: parent.right
//            anchors.rightMargin: 10
//            width: 350
//            text: {
//                if (programIndex >= WorkoutProgram.MANUAL_PROG && programIndex < WorkoutProgram.SAVED_WORKOUT) {
//                    // Subtract 3 from programIndex to account for NO_PROG and QUICK_START_PROG and TREAD_QUICK_START_PROG
//                    var str = Fields.workout_programs[(programIndex - 3)][(fieldIndex - 1)]
//                    return str ? application.translateText("Setup", str) + application.emptyString : ""
//                }
//                else if (programIndex == WorkoutProgram.SAVED_WORKOUT) {
//                    if (mainProgItem.customProgType == WorkoutProgram.CUSTOM_PACE_PROG ||
//                            mainProgItem.customProgType == WorkoutProgram.CUSTOM_HILLS_PROG ||
//                            mainProgItem.customProgType == WorkoutProgram.CUSTOM_ULTRA_PROG ||
//                            mainProgItem.customProgType == WorkoutProgram.TREAD_CUSTOM_HILLS_PROG ||
//                            mainProgItem.customProgType == WorkoutProgram.TREAD_CUSTOM_SPEED_PROG ||
//                            mainProgItem.customProgType == WorkoutProgram.TREAD_CUSTOM_ULTRA_PROG) {
//                        var str = Fields.workout_programs[(mainProgItem.customProgType - 3)][(fieldIndex - 1)]
//                        return str ? application.translateText("Setup", str) + application.emptyString : ""
//                    } else {
//                        return "NA"
//                    }
//                }
//                else {
//                    return "NA"
//                }
//            }
//            color: "black"
//            wrapMode: Text.WordWrap
//            lineHeight: 1.3
//            horizontalAlignment: Text.AlignRight
//            font.pixelSize: (text.length > 300) ? 18 : 20
//        }

//        Component {
//            id: myDelegate
//            Item {
//                id: dataElement

//                property real detailsOpacity : 0
//                property real levelDetailsOpacity : 0
//                property real expandedDetails1Opacity : 0
//                property real expandedDetails2Opacity : 0
//                property real segmentDetailsOpacity : 0
//                property string expandedState: getExpandedState(fieldType)
//                property string closedState: getClosedState(fieldType)
//                property alias _slider3: sliderObject3

//                function getExpandedState(fieldtype) {
//                    switch(fieldtype)
//                    {
//                    case WorkoutProgram.MAX_SPEED_TYPE:
//                    case WorkoutProgram.MAX_INCLINE_TYPE:
//                    case WorkoutProgram.SPEED_TYPE:
//                    case WorkoutProgram.RUN_SPEED_TYPE:
//                    case WorkoutProgram.WORK_SPEED_TYPE:
//                    case WorkoutProgram.WALK_SPEED_TYPE:
//                    case WorkoutProgram.REST_SPEED_TYPE:
//                    case WorkoutProgram.TIME_TYPE:
//                    case WorkoutProgram.PACE_TYPE:
//                    case WorkoutProgram.WORKLOAD_TYPE:
//                    case WorkoutProgram.AGE_TYPE:
//                    case WorkoutProgram.WEIGHT_TYPE:
//                    case WorkoutProgram.DISTANCE_TYPE:
//                    case WorkoutProgram.INCLINE_TYPE:
//                    case WorkoutProgram.CALORIES_TYPE:
//                        return "Details"
//                        break;
//                    case WorkoutProgram.LEVEL_TYPE:
//                        return isTreadmill ? "LevelDetails" : "Details"
//                    case WorkoutProgram.GENDER_TYPE:
//                        return "GenderDetails"
//                        break;
//                    case WorkoutProgram.DISTANCE_QUICK_TYPE:
//                        return "ExpandedDetails1"
//                        break;
//                    case WorkoutProgram.WORK_HEARTRATE_TYPE:
//                    case WorkoutProgram.REST_HEARTRATE_TYPE:
//                    case WorkoutProgram.TARGET_HEARTRATE_TYPE:
//                        return "ExpandedDetails2"
//                        break;
//                    case WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE:
//                        return "Expanded2"
//                        break;
//                    case WorkoutProgram.CALORIE_POTENTIAL_TYPE:
//                    case WorkoutProgram.FIXED_DISTANCE_TYPE:
//                    case WorkoutProgram.TIMEREADONLY_TYPE:
//                        return "Expanded3"
//                        break;
//                    case WorkoutProgram.SEGMENT_TYPE:
//                        return "SegmentDetails"
//                        break;
//                    }
//                }

//                function getClosedState(fieldtype) {
//                    switch(fieldtype)
//                    {
//                    case WorkoutProgram.WORK_HEARTRATE_TYPE:
//                    case WorkoutProgram.REST_HEARTRATE_TYPE:
//                    case WorkoutProgram.TARGET_HEARTRATE_TYPE:
//                    case WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE:
//                        return "Expanded2"
//                        break;
//                    case WorkoutProgram.FIXED_DISTANCE_TYPE:
//                    case WorkoutProgram.TIMEREADONLY_TYPE:
//                    case WorkoutProgram.CALORIE_POTENTIAL_TYPE:
//                        return "Expanded3"
//                        break;
//                    default:
//                        return ""
//                    }
//                }

//                function getItemLabel(item) {
//                    switch (item.fieldType) {
//                    case WorkoutProgram.MAX_SPEED_TYPE:
//                        if (workoutProgram.programIndex === WorkoutProgram.TREAD_CALORIE_PROG) {
//                            return QT_TRANSLATE_NOOP("WorkoutSetup", "SPEED")
//                        } else {
//                            return QT_TRANSLATE_NOOP("WorkoutSetup", "MAX SPEED")
//                        }
//                    case WorkoutProgram.MAX_INCLINE_TYPE:
//                        if (workoutProgram.programIndex === WorkoutProgram.TREAD_CALORIE_PROG) {
//                            return QT_TRANSLATE_NOOP("WorkoutSetup", "INCLINE")
//                        } else {
//                            return QT_TRANSLATE_NOOP("WorkoutSetup", "MAX INCLINE")
//                        }
//                    case WorkoutProgram.LEVEL_TYPE:
//                        if (workoutProgram.programIndex === WorkoutProgram.TREAD_LEG_SHAPER_PROG) {
//                            return QT_TRANSLATE_NOOP("WorkoutSetup", "SPEED")
//                        } else {
//                            return QT_TRANSLATE_NOOP("WorkoutSetup", "LEVEL")
//                        }
//                    case WorkoutProgram.SPEED_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "SPEED")
//                    case WorkoutProgram.RUN_SPEED_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "RUN SPEED")
//                    case WorkoutProgram.WORK_SPEED_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "WORK SPEED")
//                    case WorkoutProgram.WALK_SPEED_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "WALK SPEED")
//                    case WorkoutProgram.REST_SPEED_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "REST SPEED")
//                    case WorkoutProgram.DISTANCE_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "DISTANCE")
//                    case WorkoutProgram.DISTANCE_QUICK_TYPE:
//                    case WorkoutProgram.FIXED_DISTANCE_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "DISTANCE")
//                    case WorkoutProgram.SEGMENT_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "SEGMENTS")
//                    case WorkoutProgram.TIME_TYPE:
//                    case WorkoutProgram.TIMEREADONLY_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "WORKOUT TIME")
//                    case WorkoutProgram.PACE_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "PACE")
//                    case WorkoutProgram.WORKLOAD_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "WORKLOAD")
//                    case WorkoutProgram.AGE_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "AGE")
//                    case WorkoutProgram.WEIGHT_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "WEIGHT")
//                    case WorkoutProgram.GENDER_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "GENDER")
//                    case WorkoutProgram.INCLINE_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "INCLINE")
//                    case WorkoutProgram.CALORIES_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "CALORIE GOAL")
//                    case WorkoutProgram.CALORIE_POTENTIAL_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "CALCULATED CALORIES")

//                    case WorkoutProgram.WORK_HEARTRATE_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "WORK HEART RATE")
//                    case WorkoutProgram.REST_HEARTRATE_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "REST HEART RATE")
//                    case WorkoutProgram.TARGET_HEARTRATE_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "TARGET HEART RATE")
//                    case WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE:
//                        return QT_TRANSLATE_NOOP("WorkoutSetup", "TARGET HEART RATE")
//                    }
//                }

//                // Some items have additional text that cannot be translated
//                function getItemAdditionalLabel(item) {
//                    switch (item.fieldType) {
//                    case WorkoutProgram.PACE_TYPE:
//                    case WorkoutProgram.WORKLOAD_TYPE:
//                        return " (" + item.minValue + " - " + item.maxValue + ")"
//                    default:
//                        return ""
//                    }

//                }

//                state: ListView.isCurrentItem ? expandedState : closedState
//                width: 425
//                height: myListView.getBaseFieldHeight(model.fieldType)
//                x: 10

//                Image {
//                    id: background
//                    anchors.left: parent.left
//                    anchors.leftMargin: 5
//                    anchors.top: parent.top
//                    anchors.topMargin: 10
//                    width: 425
//                    height: dataElement.height
//                    source: myListView.getBackgroundSource(model.fieldType)
//                    z: 1

//                    MouseArea {
//                        anchors.fill: parent
//                        onClicked: {
//                            // validate a field as it is exited
//                            validateParam(myListView.currentIndex)
//                            // change to item when clicked, unless it is a read-only type
////                            if(fieldType != WorkoutProgram.HEARTRATEREADONLY_TYPE && fieldType != WorkoutProgram.FIXED_DISTANCE_TYPE)
//                                myListView.currentIndex = index

//                            // follow selected item
//                            mainProgItem.selectedIndex = indexValue.text;
//                            mainProgItem.fieldIndex = model.fieldIndex;
//                        }
//                    }
//                }
//                // folded up state elements
//                Text {
//                    id: itemName
//                    anchors.top: parent.top
//                    anchors.topMargin: 24
//                    anchors.left: parent.left
//                    anchors.leftMargin: 20
//                    text: qsTranslate("WorkoutSetup", dataElement.getItemLabel(model)) + dataElement.getItemAdditionalLabel(model) + application.emptyString
//                    font.pointSize: 20
//                    font.bold: true
//                    smooth: true
//                    color: "black"
//                    z: 2
//                }

//                Text {
//                    id: itemUnits
//                    anchors.top: parent.top
//                    anchors.topMargin: 32
//                    anchors.right: parent.right
//                    anchors.rightMargin: 20
//                    text: model.units
//                    font.pointSize: 14
//                    wrapMode: Text.WordWrap
//                    font.bold: true
//                    smooth: true
//                    color: "black"
//                    z: 2
//                }
//                Text {
//                    id: itemValue
//                    anchors.bottom: itemUnits.bottom
//                    anchors.bottomMargin: -2
//                    anchors.right: itemUnits.left
//                    anchors.rightMargin: 5
//                    text: myListView.getValueString(model)
//                    font.pointSize: 20
//                    font.bold: true
//                    smooth: true
//                    color: "black"
//                    z: 2
//                }
//                // expanded state elements
//                Text {
//                    id: itemUnitsDetails
//                    anchors.top: parent.top
//                    anchors.topMargin: 87
//                    anchors.right: parent.right
//                    anchors.rightMargin: 15
//                    text: model.units
//                    font.pointSize: 20
//                    wrapMode: Text.WordWrap
//                    font.bold: true
//                    smooth: true
//                    color: "black"
//                    z: 2
//                    visible: false
//                }
//                ImageButton {
//                    id: hrChartButton
//                    anchors.top: parent.top
//                    anchors.topMargin: 15
//                    anchors.right: parent.right
//                    anchors.rightMargin: -60
//                    downimage: "graphics/224/Data_HRC_Cruise_Down.png"
//                    upimage: "graphics/224/Data_HRC_Cruise_Up.png"
//                    icon: ""
//                    z: 2
//                    visible: {
//                        if (model.fieldType == WorkoutProgram.WORK_HEARTRATE_TYPE || model.fieldType == WorkoutProgram.REST_HEARTRATE_TYPE || model.fieldType == WorkoutProgram.TARGET_HEARTRATE_TYPE || model.fieldType == WorkoutProgram.TARGET_HEARTRATEREADONLY_TYPE) {
//                            return true;
//                        }
//                        else {
//                            return false;
//                        }
//                    }

//                    onClicked: {
//                        showHRChart();
//                    }
//                }
//                Text {
//                    // Value seen while editing expanded item
//                    id: itemValueDetails
//                    anchors.bottom: itemUnitsDetails.bottom
//                    anchors.bottomMargin: -4
//                    anchors.right: itemUnitsDetails.left
//                    anchors.rightMargin: 5
//                    text: myListView.getValueString(model)

//                    font.pointSize: 34
//                    font.bold: true
//                    smooth: true
//                    color: "black"
//                    z: 2
//                    visible: false
//                    onTextChanged: {
//                        if (mainProgItem.valueEntered) {
//                            sliderObject.value = model.dataValue;
//                            sliderObject2.value = model.dataValue;
//                            sliderObject3.value = model.dataValue;
//                            genderSlider.value = model.dataValue;
//                            print("slider change:" + model.dataValue)
//                            valueEntered = false;
//                        }
//                    }
//                }

//                Text {
//                    id: hrDividerText
//                    anchors.top: parent.top
//                    anchors.topMargin: 72
//                    anchors.horizontalCenter: parent.horizontalCenter
//                    anchors.horizontalCenterOffset: 40
//                    text: "<Center>/<br>"+qsTr("OR")+"</Center>" + application.emptyString
//                    font.pointSize: 14
//                    font.bold: true
//                    smooth: true
//                    color: "black"
//                    z: 2
//                    visible: false
//                }

//                Text {
//                    id: hrPercentageUnits
//                    anchors.top: parent.top
//                    anchors.topMargin: 83
//                    anchors.right: parent.right
//                    anchors.rightMargin: 20
//                    text: qsTr("%MAX") + application.emptyString
//                    font.pointSize: text.length > 6 ? 12 : 18
//                    wrapMode: Text.WordWrap
//                    width: 80
//                    height: 40
//                    verticalAlignment: Text.AlignBottom
//                    font.bold: true
//                    smooth: true
//                    color: "black"
//                    z: 2
//                    visible: false
//                }

//                Text {
//                    id: hrPercentageValue
//                    anchors.bottom: hrPercentageUnits.bottom
//                    anchors.bottomMargin: -6
//                    anchors.right: hrPercentageUnits.left
//                    anchors.rightMargin: 5
//                    text: model.heartRatePercentage
//                    font.pointSize: 32
//                    font.bold: true
//                    smooth: true
//                    color: "black"
//                    z: 2
//                    visible: false
//                }

//                Text {
//                    id: indexValue
//                    text: model.selectedIndex
//                    font.pointSize: 24
//                    color: "black"
//                    visible: false
//                }

//                Item {
//                    // slider control box seen after expanding most simple items (age, weight, time, etc.)
//                    id: details

//                    property int value: sliderObject.value

//                    height: 155
//                    width: 460
//                    anchors.top: dataElement.top
//                    anchors.topMargin: 85
//                    anchors.left: dataElement.left
//                    anchors.leftMargin: 50
//                    opacity: dataElement.detailsOpacity

//                    Image {
//                        id: dataIndicatorBackground
//                        anchors.horizontalCenter: parent.horizontalCenter
//                        anchors.verticalCenter: parent.verticalCenter
//                        source: "graphics/setup/Setup_Large_Up_Step2.png"
//                    }

//                    SliderControl {
//                        id: sliderObject
//                        repeat: true
//                        valueProxy: model.dataValue

//                        onValueChanged: {
//                            if (!valueEntered && !valueProxyChange) {
//                                // If time/distance has been explicitly zeroed out (e.g. from a saved manual workout being reloaded), prevent the slider
//                                // from resetting that to the min value (typically 5 minutes) and instead keep the zero value.
//                                if (value === model.minValue && ((model.fieldType === WorkoutProgram.TIME_TYPE && model.dataValue === 0) || (model.fieldType === WorkoutProgram.DISTANCE_TYPE && model.dataValue === 0))) {
//                                } else {
//                                    myListView.model.setProperty(index, "dataValue", value);
//                                    dataItemChanged()
//                                }
//                            }

//                            if (model.fieldType == WorkoutProgram.TIME_TYPE) {
//                                // segments must be 1:00 long minimum, so adjust segment max based on workout time
//                                myListView.calculateMaxSegmentsFromTime()
//                            }

//                            if (mainProgItem.targetHRType == targetHRTypeEnum.aerobic) {
//                                myListView.calculateHRFromAge();
//                            }
//                            else if (mainProgItem.targetHRType == targetHRTypeEnum.target) {
//                                myListView.calculateHRPercentage();
//                            }
//                        }
//                        showValue: false
//                        maxValue: model.maxValue
//                        minValue: model.minValue
//                        value: model.dataValue
//                        precision: model.precision
//                        stepValue: {
//                            if (model.precision == 0) {
//                                return 1;
//                            }
//                            else if (model.precision == 1) {
//                                return 0.1;
//                            }
//                        }

//                        thumbImage: "graphics/setup/Double_Arrow_Slider_Thumb_Horz.png"
//                        incrementButtonImage: "graphics/Pace_Setter_Simple_Plus.png"
//                        decrementButtonImage: "graphics/Pace_Setter_Simple_Minus.png"
//                        anchors.top: parent.top
//                        anchors.topMargin: 75
//                        anchors.left: parent.left
//                        anchors.leftMargin: 45
//                        width: 350
//                        height: 34
//                    }
//                }

//                Item {
//                    // slider control box seen after expanding gender control
//                    id: genderDetails
//                    height: 155
//                    width: 460
//                    anchors.top: dataElement.top
//                    anchors.topMargin: 85
//                    anchors.left: dataElement.left
//                    anchors.leftMargin: 50
//                    opacity: 0

//                    Image {
//                        anchors.horizontalCenter: parent.horizontalCenter
//                        anchors.verticalCenter: parent.verticalCenter
//                        source: "graphics/setup/Setup_Large_Up_Step2.png"
//                    }

//                    SliderControl {
//                        id: genderSlider

//                        onValueChanged: {
//                            if(model.fieldType != WorkoutProgram.GENDER_TYPE)
//                                return
//                            if (!valueEntered) {
//                                myListView.model.setProperty(index, "dataValue", value);
//                                dataItemChanged()
//                            }
//                        }
//                        showValue: false
//                        maxValue: 1 // FEMALE
//                        minValue: 0 // MALE
//                        value: model.dataValue
//                        precision: 0
//                        showButtons: false
//                        thumbImage: "graphics/setup/Double_Arrow_Slider_Thumb_Horz.png"
//                        anchors.top: parent.top
//                        anchors.topMargin: 75
//                        anchors.horizontalCenter: parent.horizontalCenter
//                        anchors.horizontalCenterOffset: -20
//                        width: 300 - femaleText.width - maleText.width
//                        height: 34

//                        Text {
//                            id: maleText
//                            width:paintedWidth
//                            anchors { right: parent.left ; rightMargin: 40; verticalCenter: parent.verticalCenter }
//                            text: qsTr("MALE") + application.emptyString
//                            MouseArea {
//                                anchors.fill: parent ; onClicked: genderSlider.value = 0
//                            }
//                        }

//                        Text {
//                            id: femaleText
//                            width:paintedWidth
//                            text: qsTr("FEMALE") + application.emptyString
//                            anchors { left: parent.right ; leftMargin: 40; verticalCenter : parent.verticalCenter  }
//                            MouseArea {
//                                anchors.fill: parent ; onClicked: genderSlider.value = 1
//                            }
//                        }
//                    }
//                }

//                Item {
//                    // distance selection drop-down with preset distance buttons
//                    id: expandedDetails1
//                    height: 155
//                    width: 460
//                    anchors.top: dataElement.top
//                    anchors.topMargin: 85
//                    anchors.left: dataElement.left
//                    anchors.leftMargin: 40
//                    opacity: dataElement.expandedDetails1Opacity

//                    Image {
//                        id: dataIndicatorBackground2
//                        anchors.horizontalCenter: parent.horizontalCenter
//                        anchors.verticalCenter: parent.verticalCenter
//                        source: "graphics/setup/Setup_Large_Up_Step2.png"
//                    }

//                    ImageButton {
//                        id: fiveKButton
//                        property bool valueMatches: (dataValue == 5) && (units == "K")

//                        anchors.left: dataIndicatorBackground2.left
//                        anchors.leftMargin: 50
//                        anchors.verticalCenter: dataIndicatorBackground2.verticalCenter
//                        anchors.verticalCenterOffset: 10
//                        downimage: "graphics/205/SM_Button_Down.png"
//                        upimage: valueMatches ? "graphics/205/SM_Button_Down.png": "graphics/205/SM_Button_Up.png"
//                        fontsize: 14
//                        label_color: "black"
//                        label: qsTr("5K") + application.emptyString
//                        onClicked: {
//                            myListView.model.setProperty(index, "dataValue", 5);
//                            myListView.model.setProperty(index, "units", "K");
//                            dataItemChanged()
//                        }
//                    }

//                    ImageButton {
//                        id: tenKButton
//                        property bool valueMatches: (dataValue == 10) && (units == "K")

//                        anchors.left: fiveKButton.right
//                        anchors.leftMargin: 25
//                        anchors.verticalCenter: dataIndicatorBackground2.verticalCenter
//                        anchors.verticalCenterOffset: 10
//                        downimage: "graphics/205/SM_Button_Down.png"
//                        upimage: valueMatches ? "graphics/205/SM_Button_Down.png": "graphics/205/SM_Button_Up.png"
//                        fontsize: 14
//                        label_color: "black"
//                        label: qsTr("10K") + application.emptyString
//                        onClicked: {
//                            myListView.model.setProperty(index, "dataValue", 10);
//                            myListView.model.setProperty(index, "units", "K");
//                            dataItemChanged()
//                        }
//                    }

//                    ImageButton {
//                        property bool valueMatches: (dataValue == 2) && (units == "MI")

//                        id: twoMileButton
//                        anchors.left: tenKButton.right
//                        anchors.leftMargin: 25
//                        anchors.verticalCenter: dataIndicatorBackground2.verticalCenter
//                        anchors.verticalCenterOffset: 10
//                        downimage: "graphics/205/SM_Button_Down.png"
//                        upimage: valueMatches ? "graphics/205/SM_Button_Down.png": "graphics/205/SM_Button_Up.png"
//                        fontsize: 14
//                        label_color: "black"
//                        label: qsTr("2MI") + application.emptyString
//                        onClicked: {
//                            myListView.model.setProperty(index, "dataValue", 2);
//                            myListView.model.setProperty(index, "units", "MI");
//                            dataItemChanged()
//                        }
//                    }

//                    ImageButton {
//                        property bool valueMatches: (dataValue == 4) && (units == "MI")

//                        id: fourMileButton
//                        anchors.left: twoMileButton.right
//                        anchors.leftMargin: 25
//                        anchors.verticalCenter: dataIndicatorBackground2.verticalCenter
//                        anchors.verticalCenterOffset: 10
//                        downimage: "graphics/205/SM_Button_Down.png"
//                        upimage: valueMatches ? "graphics/205/SM_Button_Down.png": "graphics/205/SM_Button_Up.png"
//                        fontsize: 14
//                        label_color: "black"
//                        label: qsTr("4MI") + application.emptyString
//                        onClicked: {
//                            myListView.model.setProperty(index, "dataValue", 4);
//                            myListView.model.setProperty(index, "units", "MI");
//                            dataItemChanged()
//                        }
//                    }
//                }

//                Item {
//                    // heart rate setting drop down sliders
//                    id: expandedDetails2
//                    height: 155
//                    width: 460
//                    anchors.top: dataElement.top
//                    anchors.topMargin: 85
//                    anchors.left: dataElement.left
//                    anchors.leftMargin: 40
//                    opacity: dataElement.expandedDetails2Opacity

//                    Image {
//                        id: dataIndicatorBackground3
//                        anchors.horizontalCenter: parent.horizontalCenter
//                        anchors.verticalCenter: parent.verticalCenter
//                        source: "graphics/setup/Setup_Large_Up_Step2.png"
//                    }

//                    SliderControl {
//                        id: sliderObject2

//                        onValueChanged: {
//                            if (model.fieldType != WorkoutProgram.WORK_HEARTRATE_TYPE &&
//                                model.fieldType != WorkoutProgram.REST_HEARTRATE_TYPE &&
//                                model.fieldType != WorkoutProgram.TARGET_HEARTRATE_TYPE)
//                                return

//                            if (!valueEntered) {
//                                myListView.model.setProperty(index, "dataValue", value);

//                                dataItemChanged()
//                            }

//                            if (mainProgItem.targetHRType == targetHRTypeEnum.aerobic) {
//                                myListView.calculateHRFromAge();
//                            }
//                            else if (mainProgItem.targetHRType == targetHRTypeEnum.target) {
//                                myListView.calculateHRPercentage();
//                            }
//                        }
//                        showValue: false
//                        maxValue: model.maxValue
//                        minValue: model.minValue
//                        value: model.dataValue
//                        thumbImage: "graphics/setup/Double_Arrow_Slider_Thumb_Horz.png"
//                        incrementButtonImage: "graphics/Pace_Setter_Simple_Plus.png"
//                        decrementButtonImage: "graphics/Pace_Setter_Simple_Minus.png"
//                        anchors.top: parent.top
//                        anchors.topMargin: 75
//                        anchors.left: parent.left
//                        anchors.leftMargin: 45
//                        width: 350
//                        height: 34
//                    }
//                }

//                Item {
//                    // drop down slider for setting number of segments for custom profile programs
//                    id: segmentDetails
//                    height: 155
//                    width: 460
//                    anchors.top: dataElement.top
//                    anchors.topMargin: 85
//                    anchors.left: dataElement.left
//                    anchors.leftMargin: 50
//                    opacity: dataElement.segmentDetailsOpacity

//                    Image {
//                        id: dataIndicatorBackground5
//                        anchors.top: sliderObject3.top
//                        anchors.topMargin: 15
//                        anchors.left: sliderObject3.left
//                        anchors.leftMargin: 15
//                        source: "graphics/setup/Setup_Large_Up_Step3.png"
//                    }

//                    Text {
//                        id: calculatedSegTime1
//                        anchors.verticalCenter: dataIndicatorBackground5.verticalCenter
//                        anchors.left: dataIndicatorBackground5.left
//                        anchors.leftMargin: 30
//                        text: qsTr("SEGMENT TIME") + application.emptyString
//                        font.pointSize: 18
//                        font.bold: true
//                        smooth: true
//                        color: "black"
//                        z: 2
//                    }

//                    Text {
//                        id: calculatedSegTimeValue1
//                        anchors.verticalCenter: dataIndicatorBackground5.verticalCenter
//                        anchors.right: dataIndicatorBackground5.right
//                        anchors.rightMargin: 40
//                        text: Format.formatTimeString(mainProgItem.segTime);
//                        font.pointSize: 32
//                        font.bold: true
//                        smooth: true
//                        color: "black"
//                        z: 2
//                    }

//                    Text {
//                        id: calculatedSegTimeNote
//                        anchors.verticalCenter: dataIndicatorBackground5.verticalCenter
//                        anchors.verticalCenterOffset: 30
//                        anchors.right: dataIndicatorBackground5.right
//                        anchors.rightMargin: 40
//                        text: qsTr("(MINIMUM SEGMENT TIME IS 1:00)") + application.emptyString
//                        font.pointSize: 12
//                        font.bold: true
//                        smooth: true
//                        color: "black"
//                        z: 2
//                    }

//                    Image {
//                        id: dataIndicatorBackground4
//                        anchors.horizontalCenter: parent.horizontalCenter
//                        anchors.verticalCenter: parent.verticalCenter
//                        source: "graphics/setup/Setup_Large_Up_Step2.png"
//                    }

//                    SliderControl {
//                        id: sliderObject3

//                        onValueChanged: {
//                            if (model.fieldType == WorkoutProgram.SEGMENT_TYPE) {
//                                myListView.model.setProperty(index, "dataValue", value);
//                                mainProgItem.numSegs = value;
//                                dataItemChanged()
//                            }
//                        }
//                        showValue: false
//                        minValue: model.minValue
//                        maxValue: model.maxValue
//                        value: model.dataValue
//                        precision: model.precision
//                        stepValue: {
//                            if (model.precision == 0) {
//                                return 1;
//                            }
//                            else if (model.precision == 1) {
//                                return 0.1;
//                            }
//                        }

//                        thumbImage: "graphics/setup/Double_Arrow_Slider_Thumb_Horz.png"
//                        incrementButtonImage: "graphics/Pace_Setter_Simple_Plus.png"
//                        decrementButtonImage: "graphics/Pace_Setter_Simple_Minus.png"
//                        anchors.top: parent.top
//                        anchors.topMargin: 75
//                        anchors.left: parent.left
//                        anchors.leftMargin: 45
//                        width: 350
//                        height: 34
//                    }
//                }

//                Item {
//                    id: levelDetails
//                    height: 155
//                    width: 460
//                    anchors.top: dataElement.top
//                    anchors.topMargin: 175
//                    anchors.left: dataElement.left
//                    anchors.leftMargin: 110
//                    z: details.z - 1
//                    opacity: dataElement.levelDetailsOpacity

//                    Text {
//                        id: levelSubLabel
//                        function getLabel() {
//                            switch (workoutProgram.programIndex) {
//                                case WorkoutProgram.TREAD_CARDIO_CHALLENGE_PROG:
//                                case WorkoutProgram.TREAD_GLUTE_BUSTER_PROG:
//                                case WorkoutProgram.TREAD_HILL_INTERVALS_PROG:
//                                case WorkoutProgram.TREAD_ROLLING_HILLS_PROG:
//                                case WorkoutProgram.TREAD_SINGLE_HILL_PROG:
//                                case WorkoutProgram.TREAD_WEIGHT_LOSS_HILLS_PROG:
//                                case WorkoutProgram.TREAD_RANDOM_HILLS_PROG:
//                                    return qsTr("MAXIMUM INCLINE")
//                                case WorkoutProgram.TREAD_LEG_SHAPER_PROG:
//                                    return qsTr("MAXIMUM SPEED")
//                                default:
//                                    return ""
//                            }
//                        }
//                        anchors.verticalCenter: dataIndicatorBackground7.verticalCenter
//                        anchors.left: dataIndicatorBackground7.left
//                        anchors.leftMargin: 30
//                        text: getLabel() + application.emptyString
//                        font.pointSize: 18
//                        font.bold: true
//                        smooth: true
//                        color: "black"
//                        z: 2
//                    }

//                    Text {
//                        id: levelSubValue
//                        function getProfile() {
//                            switch (workoutProgram.programIndex) {
//                                case WorkoutProgram.TREAD_CARDIO_CHALLENGE_PROG:
//                                case WorkoutProgram.TREAD_GLUTE_BUSTER_PROG:
//                                case WorkoutProgram.TREAD_HILL_INTERVALS_PROG:
//                                case WorkoutProgram.TREAD_ROLLING_HILLS_PROG:
//                                case WorkoutProgram.TREAD_SINGLE_HILL_PROG:
//                                case WorkoutProgram.TREAD_WEIGHT_LOSS_HILLS_PROG:
//                                case WorkoutProgram.TREAD_RANDOM_HILLS_PROG:
//                                    return workoutProgram.profile1 // incline
//                                case WorkoutProgram.TREAD_LEG_SHAPER_PROG:
//                                    return workoutProgram.profile2 // speed
//                            }
//                        }
//                        anchors.verticalCenter: dataIndicatorBackground7.verticalCenter
//                        anchors.right: levelSubUnits.left
//                        anchors.rightMargin: 1
//                        text: {
//                            if (levelDetails.opacity < 1) return ""

//                            var profile = getProfile()
//                            var result = profile.findMaxWithLevel("segmentMagnitude", details.value)
//                            result = parseInt(result)/10.0
//                            if (options.metricUnits && profile.segmentType === WorkoutProfile.SPEED_SEG_TYPE)
//                                result = Globals.mileToKm(result)

//                            return result.toFixed(1)
//                        }
//                        font.pointSize: 32
//                        font.bold: true
//                        smooth: true
//                        color: "black"
//                        z: 2
//                    }

//                    Text {
//                        id: levelSubUnits
//                        function getUnits() {
//                            switch (workoutProgram.programIndex) {
//                                case WorkoutProgram.TREAD_CARDIO_CHALLENGE_PROG:
//                                case WorkoutProgram.TREAD_GLUTE_BUSTER_PROG:
//                                case WorkoutProgram.TREAD_HILL_INTERVALS_PROG:
//                                case WorkoutProgram.TREAD_ROLLING_HILLS_PROG:
//                                case WorkoutProgram.TREAD_SINGLE_HILL_PROG:
//                                case WorkoutProgram.TREAD_WEIGHT_LOSS_HILLS_PROG:
//                                case WorkoutProgram.TREAD_RANDOM_HILLS_PROG:
//                                    return "%"
//                                case WorkoutProgram.TREAD_LEG_SHAPER_PROG:
//                                    return options.metricUnits ? "KPH" : "MPH"
//                                default:
//                                    return ""
//                            }
//                        }
//                        anchors.bottomMargin: height/2
//                        anchors.bottom: levelSubValue.bottom
//                        anchors.right: dataIndicatorBackground7.right
//                        anchors.rightMargin: 40
//                        text: getUnits() + application.emptyString
//                        font.pointSize: 12
//                        font.bold: true
//                        smooth: true
//                        color: "black"
//                        z: 2
//                    }

//                    Image {
//                        id: dataIndicatorBackground7
//                        anchors.horizontalCenter: parent.horizontalCenter
//                        anchors.verticalCenter: parent.verticalCenter
//                        source: "graphics/setup/Setup_Large_Up_Step3.png"
//                    }

//                }

//                states: [
//                    State {
//                        name: "Details"
//                        PropertyChanges { target: background; height: 160; width: 455; anchors.leftMargin: -1; anchors.topMargin: 1; source: "graphics/setup/Setup_Large_Up_Step1.png" }
//                        PropertyChanges { target: itemValue; opacity: 0.0}
//                        PropertyChanges { target: itemUnits; visible: false}
//                        PropertyChanges { target: itemValueDetails; visible: true }
//                        PropertyChanges { target: itemUnitsDetails; visible: true }
//                        PropertyChanges { target: dataElement; height: 225 } // Fill the entire list area with the detailed view
//                        PropertyChanges { target: dataElement; detailsOpacity: 1} // Make details visible
//                    },
//                    State {
//                        name: "LevelDetails"
//                        PropertyChanges { target: background; height: 160; width: 455; anchors.leftMargin: -1; anchors.topMargin: 1; source: "graphics/setup/Setup_Large_Up_Step1.png" }
//                        PropertyChanges { target: itemValue; opacity: 0.0}
//                        PropertyChanges { target: itemUnits; visible: false}
//                        PropertyChanges { target: itemValueDetails; visible: true }
//                        PropertyChanges { target: itemUnitsDetails; visible: true }
//                        PropertyChanges { target: dataElement; height: 315 } // Fill the entire list area with the detailed view
//                        PropertyChanges { target: dataElement; detailsOpacity: 1} // Make details visible
//                        PropertyChanges { target: dataElement; levelDetailsOpacity: 1} // Make details visible
//                    },
//                    State {
//                        name: "ExpandedDetails1"
//                        PropertyChanges { target: background; height: 160; width: 455; anchors.leftMargin: -1; anchors.topMargin: 1; source: "graphics/setup/Setup_Large_Up_Step1.png" }
//                        PropertyChanges { target: itemValue; opacity: 0.0}
//                        PropertyChanges { target: itemUnits; visible: false}
//                        PropertyChanges { target: itemValueDetails; visible: true }
//                        PropertyChanges { target: itemUnitsDetails; visible: true }
//                        PropertyChanges { target: dataElement; height: 225 } // Fill the entire list area with the detailed view
//                        PropertyChanges { target: dataElement; expandedDetails1Opacity: 1} // Make details visible
//                    },
//                    State {
//                        name: "Expanded2"
//                        PropertyChanges { target: itemUnits; anchors.top: parent.top;
//                            anchors.topMargin: application.currentLanguage == "ar" ? 60 : 90;
//                            anchors.right: parent.right; anchors.rightMargin: 200;
//                            width: application.currentLanguage == "ar" ? 120 : implicitWidth;
//                            font.pointSize: application.currentLanguage == "ar" ? 12 : 18
//                        }
//                        PropertyChanges { target: itemValue; anchors.bottomMargin: -6; font.pointSize: 32 }
//                        PropertyChanges { target: hrDividerText; visible: true }
//                        PropertyChanges { target: hrPercentageValue; visible: true }
//                        PropertyChanges { target: hrPercentageUnits; visible: true }
//                    },
//                    State {
//                        name: "Expanded3"
//                        PropertyChanges { target: itemUnits; anchors.top: parent.top; anchors.topMargin: 90; anchors.right: parent.right; anchors.rightMargin: 20; font.pointSize: 18 }
//                        PropertyChanges { target: itemValue; anchors.bottomMargin: -6; font.pointSize: 32 }
//                    },
//                    State {
//                        name: "ExpandedDetails2"
//                        PropertyChanges { target: background; height: 160; width: 455; anchors.leftMargin: -1; anchors.topMargin: 1; source: "graphics/setup/Setup_Large_Up_Step1.png" }
//                        PropertyChanges { target: itemValue; opacity: 0.0}
//                        PropertyChanges { target: itemUnits; visible: false}
//                        PropertyChanges { target: itemUnitsDetails; anchors.top: parent.top;
//                            anchors.topMargin: application.currentLanguage == "ar" ? 81 : 90;
//                            anchors.right: parent.right; anchors.rightMargin: 200;
//                            font.pointSize: application.currentLanguage == "ar" ? 12 : 18;
//                            width: application.currentLanguage == "ar" ? 140 : implicitWidth
//                        }
//                        PropertyChanges { target: itemValueDetails; anchors.bottomMargin: -6; font.pointSize: 32 }
//                        PropertyChanges { target: itemValueDetails; visible: true }
//                        PropertyChanges { target: itemUnitsDetails; visible: true }
//                        PropertyChanges { target: hrDividerText; visible: true }
//                        PropertyChanges { target: hrPercentageValue; visible: true }
//                        PropertyChanges { target: hrPercentageUnits; visible: true }
//                        PropertyChanges { target: dataElement; height: 225 } // Fill the entire list area with the detailed view
//                        PropertyChanges { target: dataElement; expandedDetails2Opacity: 1} // Make details visible
//                    },
//                    State {
//                        name: "SegmentDetails"
//                        PropertyChanges { target: background; height: 160; width: 455; anchors.leftMargin: -1; anchors.topMargin: 1; source: "graphics/setup/Setup_Large_Up_Step1.png" }
//                        PropertyChanges { target: itemValue; opacity: 0.0}
//                        PropertyChanges { target: itemUnits; visible: false}
//                        PropertyChanges { target: itemValueDetails; visible: true }
//                        PropertyChanges { target: itemUnitsDetails; visible: true }
//                        PropertyChanges { target: dataElement; height: 315 } // Fill the entire list area with the detailed view
//                        PropertyChanges { target: dataElement; segmentDetailsOpacity: 1} // Make details visible
//                    },
//                    State {
//                        name: "GenderDetails"
//                        PropertyChanges { target: background; height: 160; width: 455; anchors.leftMargin: -1; anchors.topMargin: 1; source: "graphics/setup/Setup_Large_Up_Step1.png" }
//                        PropertyChanges { target: itemValue; opacity: 0.0}
//                        PropertyChanges { target: itemUnits; visible: false}
//                        PropertyChanges { target: itemValueDetails; visible: true }
//                        PropertyChanges { target: itemUnitsDetails; visible: true }
//                        PropertyChanges { target: dataElement; height: 225 } // Fill the entire list area with the detailed view
//                        PropertyChanges { target: genderDetails; opacity: 1} // Make details visible
//                    }

//                ]

//                transitions: [
//                    Transition {
//                        to: "Details"
//                        reversible: true
//                    },
//                    Transition {
//                        to: "ExpandedDetails1"
//                        reversible: true
//                    },
//                    Transition {
//                        to: "ExpandedDetails2"
//                        reversible: true
//                    },
//                    Transition {
//                        to: "SegmentDetails"
//                        reversible: true
//                    }
//                ]
//            }
//        }
//    }

//    Rectangle { id: cautionMessage

//        property variant item: myListView.model ? myListView.model.get(selectedIndex) : undefined
//        property bool showInclineMessage: item !== undefined && isTreadmill && (item.fieldType === WorkoutProgram.INCLINE_TYPE || item.fieldType === WorkoutProgram.MAX_INCLINE_TYPE || (item.fieldType === WorkoutProgram.LEVEL_TYPE && workoutProgram.programIndex !== WorkoutProgram.TREAD_LEG_SHAPER_PROG))
//        property bool showWorkloadMessage: item !== undefined && !isTreadmill && (item.fieldType === WorkoutProgram.LEVEL_TYPE || item.fieldType === WorkoutProgram.WORKLOAD_TYPE)
//        property bool showSpeedMessage: item !== undefined && (isSpeedType(item.fieldType) || (item.fieldType === WorkoutProgram.LEVEL_TYPE && workoutProgram.programIndex === WorkoutProgram.TREAD_LEG_SHAPER_PROG))

//        visible: showInclineMessage || showWorkloadMessage || showSpeedMessage

//        anchors.bottom: parent.bottom
//        anchors.bottomMargin: 10
//        anchors.left: parent.left
//        anchors.leftMargin: 10
//        width: childrenRect.width
//        height:childrenRect.height
//        color: "#e8e8e8"

//        Image{
//            id: cautionSymbol
//            source: "graphics/Icon_Warning.png"
//        }

//        Text{
//            id: cautionTitle
//            text: qsTr("CAUTION") + application.emptyString
//            font.bold: true
//            font.pixelSize: 22
//            anchors.left: cautionSymbol.right
//            anchors.leftMargin: 5
//            anchors.verticalCenter: cautionSymbol.verticalCenter
//            anchors.verticalCenterOffset: 0
//        }

//        Text{
//            id: cautionText
//            width: 450
//            wrapMode: Text.WordWrap
//            text: {
//                if (cautionMessage.showInclineMessage)
//                    return qsTr("Use caution when selecting incline level. Injury can result if not prepared for incline levels beyond your physical limits.") + application.emptyString
//                else if (cautionMessage.showWorkloadMessage)
//                    return qsTr("Use caution when selecting level. Injury can result if not prepared for workload resistance beyond your physical limits.") + application.emptyString
//                else if (cautionMessage.showSpeedMessage)
//                    return qsTr("Use caution when selecting speed. Injury can result if not prepared for speeds beyond your physical limits.") + application.emptyString
//                else
//                    return ""
//            }
//            font.pixelSize: 16
//            anchors.left: cautionSymbol.right
//            anchors.leftMargin: 5
//            anchors.top: cautionTitle.bottom
//            anchors.topMargin: 5
//        }
//    }

//}

