#!/bin/sh

EXPORT_ROOT=$1
SCRIPTDIR=$(cd "$( dirname "$0" )" && pwd )

SERIAL=$(sh $SCRIPTDIR/product_serial.sh)
if [ -z "$SERIAL" ] ; then
    SERIAL="unknown-serial"
fi

BIOSVER=$(sudo cat /sys/class/dmi/id/bios_version)
TUNERTYPE=$(sh $SCRIPTDIR/tunertype.sh)
DIAGDIR=$EXPORT_ROOT/$SERIAL-diag-$(date +%s)

mkdir $DIAGDIR
dpkg -l > $DIAGDIR/dpkg.log
echo $SERIAL > $DIAGDIR/serialnumber
echo $TUNERTYPE > $DIAGDIR/tunertype
echo $BIOSVER > $DIAGDIR/biosversion
lsusb > $DIAGDIR/lsusb.log
dmesg -T > $DIAGDIR/dmesg.log
cp /data/logs/* $DIAGDIR
sudo cp /var/log/auth* $DIAGDIR
sudo cp /var/log/syslog* $DIAGDIR
sudo cp /var/log/kern.log* $DIAGDIR
sudo cp /var/log/dmesg* $DIAGDIR
sudo cp /var/log/udev $DIAGDIR
cp /var/log/Xorg.0.log* $DIAGDIR

mkdir $DIAGDIR/netpulse
cp /netpulse/logs/error.log* $DIAGDIR/netpulse
sync
